<?php
/**
 * Event Decorations functions and definitions
 * @package Event Decorations
 */

if ( ! function_exists( 'event_decorations_after_theme_support' ) ) :

	function event_decorations_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support('woocommerce');
        add_theme_support('wc-product-gallery-zoom');
        add_theme_support('wc-product-gallery-lightbox');
        add_theme_support('wc-product-gallery-slider');
        add_theme_support('woocommerce', array(
            'gallery_thumbnail_image_width' => 300,
        ));

		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

		$GLOBALS['content_width'] = apply_filters( 'event_decorations_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
		    'video',
		    'audio',
		    'gallery',
		    'quote',
		    'image'
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'wp-block-styles' );

		require get_template_directory() . '/inc/metabox.php';
		require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';

		if (! defined( 'EVENT_DECORATIONS_DOCS_PRO' ) ){
			define('EVENT_DECORATIONS_DOCS_PRO',__('https://layout.omegathemes.com/steps/agriculture-farm-pro/','event-decorations'));
		}
		if (! defined( 'EVENT_DECORATIONS_BUY_NOW' ) ){
			define('EVENT_DECORATIONS_BUY_NOW',__('https://www.omegathemes.com/products/event-wordpress-theme','event-decorations'));
		}
		if (! defined( 'EVENT_DECORATIONS_SUPPORT_FREE' ) ){
			define('EVENT_DECORATIONS_SUPPORT_FREE',__('https://wordpress.org/support/theme/event-decorations/','event-decorations'));
		}
		if (! defined( 'EVENT_DECORATIONS_REVIEW_FREE' ) ){
			define('EVENT_DECORATIONS_REVIEW_FREE',__('https://wordpress.org/support/theme/event-decorations/reviews/#new-post/','event-decorations'));
		}
		if (! defined( 'EVENT_DECORATIONS_DEMO_PRO' ) ){
			define('EVENT_DECORATIONS_DEMO_PRO',__('https://layout.omegathemes.com/event-decorations/','event-decorations'));
		}
		if (! defined('EVENT_DECORATIONS_LITE_DOCS_PRO') ){
			define('EVENT_DECORATIONS_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/event-decorations/','event-decorations'));
		}
		if (! defined('EVENT_DECORATIONS_BUNDLE_BUTTON') ){
			define('EVENT_DECORATIONS_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','event-decorations'));
		}

	}

endif;

add_action( 'after_setup_theme', 'event_decorations_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function event_decorations_register_styles() {

	wp_enqueue_style( 'dashicons' );

    $event_decorations_theme_version = wp_get_theme()->get( 'Version' );
	$event_decorations_fonts_url = event_decorations_fonts_url();
    if( $event_decorations_fonts_url ){
    	require_once get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'event-decorations-google-fonts',
			event_decorations_wptt_get_webfont_url( $event_decorations_fonts_url ),
			array(),
			$event_decorations_theme_version
		);
    }

    wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper-bundle.min.css');
    wp_enqueue_style( 'owl.carousel', get_template_directory_uri() . '/lib/custom/css/owl.carousel.min.css');
	wp_enqueue_style( 'event-decorations-style', get_stylesheet_uri(), array(), $event_decorations_theme_version );

	wp_enqueue_style( 'event-decorations-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'event-decorations-style',$event_decorations_custom_css );

	$event_decorations_css = '';

	if ( get_header_image() ) :

		$event_decorations_css .=  '
			#center-header{
				background-image: url('.esc_url(get_header_image()).') !important;
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
			}';

	endif;

	wp_add_inline_style( 'event-decorations-style', $event_decorations_css );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper-bundle.min.js', array('jquery'), '', 1);
	wp_enqueue_script( 'event-decorations-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);
	wp_enqueue_script( 'owl.carousel', get_template_directory_uri() . '/lib/custom/js/owl.carousel.js', array('jquery'), '', 1);

    // Global Query
    if( is_front_page() ){

    	$event_decorations_posts_per_page = absint( get_option('posts_per_page') );
        $event_decorations_c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $event_decorations_posts_args = array(
            'posts_per_page'        => $event_decorations_posts_per_page,
            'paged'                 => $event_decorations_c_paged,
        );
        $event_decorations_posts_qry = new WP_Query( $event_decorations_posts_args );
        $max = $event_decorations_posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $max = $wp_query->max_num_pages;
        $event_decorations_c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $event_decorations_default = event_decorations_get_default_theme_options();
    $event_decorations_pagination_layout = get_theme_mod( 'event_decorations_pagination_layout',$event_decorations_default['event_decorations_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'event_decorations_register_styles',200 );

function event_decorations_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('event-decorations-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'event_decorations_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */
function event_decorations_menus() {

	$event_decorations_locations = array(
		'event-decorations-primary-menu'  => esc_html__( 'Primary Menu', 'event-decorations' ),
	);

	register_nav_menus( $event_decorations_locations );
}

add_action( 'init', 'event_decorations_menus' );

add_filter('loop_shop_columns', 'event_decorations_loop_columns');
if (!function_exists('event_decorations_loop_columns')) {
	function event_decorations_loop_columns() {
		$event_decorations_columns = get_theme_mod( 'event_decorations_per_columns', 3 );
		return $event_decorations_columns;
	}
}

add_filter( 'loop_shop_per_page', 'event_decorations_per_page', 20 );
function event_decorations_per_page( $event_decorations_cols ) {
  	$event_decorations_cols = get_theme_mod( 'event_decorations_product_per_page', 9 );
	return $event_decorations_cols;
}

add_filter( 'woocommerce_output_related_products_args', 'event_decorations_products_args' );

function event_decorations_products_args( $event_decorations_args ) {

    $event_decorations_args['posts_per_page'] = get_theme_mod( 'event_decorations_custom_related_products_number', 6 );

    $event_decorations_args['columns'] = get_theme_mod( 'event_decorations_custom_related_products_number_per_row', 3 );

    return $event_decorations_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';


function event_decorations_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'event_decorations_remove_customize_register', 11 );

// Apply styles based on customizer settings

function event_decorations_radio_sanitize(  $event_decorations_input, $event_decorations_setting  ) {
	$event_decorations_input = sanitize_key( $event_decorations_input );
	$event_decorations_choices = $event_decorations_setting->manager->get_control( $event_decorations_setting->id )->choices;
	return ( array_key_exists( $event_decorations_input, $event_decorations_choices ) ? $event_decorations_input : $event_decorations_setting->default );
}
require get_template_directory() . '/inc/general.php';

function event_decorations_sticky_sidebar_enabled() {
    $event_decorations_sticky_sidebar = get_theme_mod('event_decorations_sticky_sidebar', true);
    
    if ($event_decorations_sticky_sidebar == false) {
        $event_decorations_custom_css = ".widget-area-wrapper { position: relative !important; }";
        wp_add_inline_style('event-decorations-style', $event_decorations_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'event_decorations_sticky_sidebar_enabled');

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

// NOTICE FUNCTION

function event_decorations_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'event_decorations_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_eventdecorations-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing Event Decorations. Let’s Set Up Your Website!', 'event-decorations') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'event-decorations') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=eventdecorations-wizard' ) ); ?>"><?php esc_html_e('Get Started with Event Decorations', 'event-decorations'); ?></a>
					<a target="_blank" href="<?php echo esc_url( EVENT_DECORATIONS_BUNDLE_BUTTON ); ?>" class="notice-bundle"><?php esc_html_e('Get All WP Themes', 'event-decorations'); ?></a>
                </div>
                <p class="dismiss-link"><strong><a href="?event_decorations_admin_notice=1"><?php esc_html_e( 'Dismiss', 'event-decorations' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'event_decorations_admin_notice' );

if ( ! function_exists( 'event_decorations_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function event_decorations_update_admin_notice() {
    if ( isset( $_GET['event_decorations_admin_notice'] ) && $_GET['event_decorations_admin_notice'] == '1' ) {
        update_option( 'event_decorations_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'event_decorations_update_admin_notice' );

// After Switch theme function
add_action( 'after_switch_theme', 'event_decorations_getstart_setup_options' );
function event_decorations_getstart_setup_options() {
    update_option( 'event_decorations_admin_notice', false );
}